.\" $NetBSD: vge.4,v 1.4 2005/03/05 14:39:29 jdolecek Exp $
.\"
.\" Copyright (c) 2004
.\"	Bill Paul <wpaul@windriver.com>. All rights reserved.
.\"
.\" Redistribution and use in source and binary forms, with or without
.\" modification, are permitted provided that the following conditions
.\" are met:
.\" 1. Redistributions of source code must retain the above copyright
.\"    notice, this list of conditions and the following disclaimer.
.\" 2. Redistributions in binary form must reproduce the above copyright
.\"    notice, this list of conditions and the following disclaimer in the
.\"    documentation and/or other materials provided with the distribution.
.\" 3. All advertising materials mentioning features or use of this software
.\"    must display the following acknowledgement:
.\"	This product includes software developed by Bill Paul.
.\" 4. Neither the name of the author nor the names of any co-contributors
.\"    may be used to endorse or promote products derived from this software
.\"   without specific prior written permission.
.\"
.\" THIS SOFTWARE IS PROVIDED BY Bill Paul AND CONTRIBUTORS ``AS IS'' AND
.\" ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE
.\" IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE
.\" ARE DISCLAIMED.  IN NO EVENT SHALL Bill Paul OR THE VOICES IN HIS HEAD
.\" BE LIABLE FOR ANY DIRECT, INDIRECT, INCIDENTAL, SPECIAL, EXEMPLARY, OR
.\" CONSEQUENTIAL DAMAGES (INCLUDING, BUT NOT LIMITED TO, PROCUREMENT OF
.\" SUBSTITUTE GOODS OR SERVICES; LOSS OF USE, DATA, OR PROFITS; OR BUSINESS
.\" INTERRUPTION) HOWEVER CAUSED AND ON ANY THEORY OF LIABILITY, WHETHER IN
.\" CONTRACT, STRICT LIABILITY, OR TORT (INCLUDING NEGLIGENCE OR OTHERWISE)
.\" ARISING IN ANY WAY OUT OF THE USE OF THIS SOFTWARE, EVEN IF ADVISED OF
.\" THE POSSIBILITY OF SUCH DAMAGE.
.\"
.\" FreeBSD: src/share/man/man4/vge.4,v 1.7 2005/01/14 10:33:39 ru Exp
.\"
.Dd March 5, 2005
.Dt VGE 4
.Os
.Sh NAME
.Nm vge
.Nd "VIA Networking Technologies VT6122 PCI Gigabit Ethernet adapter driver"
.Sh SYNOPSIS
.Cd "vge* at pci? dev ? function ?"
.Pp
Configuration of PHYs is also necessary.  See
.Xr mii 4 .
.Sh DESCRIPTION
The
.Nm
driver provides support for various NICs and embedded Ethernet interfaces
based on the VIA Networking Technologies VT6122 Gigabit Ethernet
controller chips.
.Pp
The VT6122 is a 33/66Mhz 64-bit PCI device which combines a tri-speed MAC with
an integrated 10/100/1000 copper PHY.
(Some older cards use an external PHY.)
The MAC supports TCP/IP hardware
checksums (IPv4 only), TCP large send, VLAN tag insertion and stripping,
as well as VLAN filtering, a 64-entry CAM filter and a 64-entry VLAN filter,
64-bit multicast hash filter, 4 separate transmit DMA queues, flow control
and jumbo frames up to 16K in size.
The VT6122 has a 16K receive FIFO and 48K transmit FIFO.
.Pp
The
.Nm
driver takes advantage of the VT6122's checksum offload and VLAN
tagging features, as well as the jumbo frame and CAM filter support.
The CAM filter is used for multicast address filtering to provide
64 perfect multicast address filter support.
If it is necessary for the interface to join more than 64 multicast
groups, the driver will switch over to using the hash filter.
.Pp
The jumbo frame support can be enabled by setting the interface MTU
to any value larger than the default of 1500 bytes, up to a maximum
of 9000 bytes.
The receive and transmit checksum offload support
can be toggled on and off using the
.Xr ifconfig 8
utility.
.Pp
The
.Nm
driver supports the following media types:
.Bl -tag -width ".Cm 10baseT/UTP"
.It Cm autoselect
Enable autoselection of the media type and options.
The user can manually override
the autoselected mode by adding media options to
.Xr rc.conf 5 .
.It Cm 10baseT/UTP
Set 10Mbps operation.
The
.Xr ifconfig 8
.Cm mediaopt
option can also be used to select either
.Cm full-duplex
or
.Cm half-duplex
modes.
.It Cm 100baseTX
Set 100Mbps (Fast Ethernet) operation.
The
.Xr ifconfig 8
.Cm mediaopt
option can also be used to select either
.Cm full-duplex
or
.Cm half-duplex
modes.
.It Cm 1000baseTX
Set 1000baseTX operation over twisted pair.
The
.Xr ifconfig 8
.Cm mediaopt
option can also be used to select either
.Cm full-duplex
or
.Cm half-duplex
modes.
.El
.Pp
The
.Nm
driver supports the following media options:
.Bl -tag -width ".Cm full-duplex"
.It Cm full-duplex
Force full duplex operation.
.It Cm half-duplex
Force half duplex operation.
.El
.Pp
The
.Nm
driver also supports one special link option for 1000baseTX cards:
.Bl -tag -width ".Cm link0"
.It Cm link0
With 1000baseTX cards, establishing a link between two ports requires
that one port be configured as a master and the other a slave.
With autonegotiation,
the master/slave settings will be chosen automatically.
However when manually selecting the link state, it is necessary to
force one side of the link to be a master and the other a slave.
The
.Nm
driver configures the ports as slaves by default.
Setting the
.Cm link0
flag with
.Xr ifconfig 8
will set a port as a master instead.
.El
.Pp
For more information on configuring this device, see
.Xr ifconfig 8 .
.Sh HARDWARE
The
.Nm
driver supports VIA Networking VT3119 and VT6122 based
Gigabit Ethernet adapters including:
.Pp
.Bl -bullet -compact
.It
VIA Networking LAN-on-motherboard Gigabit Ethernet
.It
ZyXEL GN650-T 64-bit PCI Gigabit Ethernet NIC (ZX1701)
.It
ZyXEL GN670-T 32-bit PCI Gigabit Ethernet NIC (ZX1702)
.El
.Sh DIAGNOSTICS
.Bl -diag
.It "vge%d: couldn't map memory"
The driver failed to initialize PCI shared memory mapping.
This might
happen if the card is not in a bus-master slot.
.It "vge%d: unable to map interrupt"
A fatal initialization error has occurred.
.It "vge%d: watchdog timeout"
The device has stopped responding to the network, or there is a problem with
the network connection (cable). Driver resets the device.
.El
.Sh SEE ALSO
.Xr arp 4 ,
.Xr ciphy 4 ,
.Xr mii 4 ,
.Xr netintro 4 ,
.Xr ukphy 4 ,
.Xr vlan 4 ,
.Xr ifconfig 8
.Sh HISTORY
The
.Nm
device driver first appeared in
.Fx 5.3
and then in
.Nx 3.0 .
.Sh AUTHORS
.An -nosplit
The
.Nm
driver was written by
.An Bill Paul Aq wpaul@windriver.com .
The
.Nx
port was done by
.An Jaromir Dolecek
.Aq jdolecek@NetBSD.org .
.Sh BUGS
VLAN packet filtering is done in software at the moment, though
using hardware VLAN tagging.
